<!--
 * @Author: skystar-chen 3034474728@qq.com
 * @Date: 2022-09-12 10:39:31
 * @LastEditors: skystar-chen 3034474728@qq.com
 * @LastEditTime: 2022-09-12 23:46:09
 * @FilePath: \text-overflow-processor-react-test\README.md
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
-->
# 文本溢出处理

当文案在给定容器显示不下时，可以尝试使用本组件TextOverflowProcessor进行处理，提供`ellipsis`和`shadow`两种处理方式

> 作者：陈星~

## 一、安装

```shell
npm i text-overflow-processor-react -S
```

或

```shell
yarn add text-overflow-processor-react
```

## 二、引用

```react
import TextOverFlowProcessor from 'text-overflow-processor-react'
```



## 三、参数注解

```typescript
interface TextProcessProps {
  type?: 'shadow' | 'ellipsis'; // 文案处理类型
  unfoldButtonText?: string  | JSX.Element | JSX.Element[]; // 展开时按钮文案
  foldButtonText?: string  | JSX.Element | JSX.Element[]; // 折叠时按钮文案
  buttonBeforeSlot?: string | JSX.Element | JSX.Element[]; // 按钮前面的空格可以传''空去除
  buttonClassName?: string;
  buttonStyle?: React.CSSProperties;
  text: string; // 文本内容，shadow时支持传DOM（注：尽量传string文案）
  lineHeight?: number;
  ellipsisLineClamp?: number; // type类型为ellipsis时控制显示的行数
  className?: string;
  style?: React.CSSProperties;
  isShowAllContent?: boolean;
  isMustButton?: boolean; // 是否常驻显示按钮
  isMustNoButton?: boolean; // 是否不要显示按钮
  shadowInitBoxShowH?: number; // shadow时显示的高度，超出这个高度才出现操作按钮
  onClick?: () => void;
  getIsFold?: (v: boolean) => void; // 获取文案是否超出范围被折叠
}
```

